// Htm.h : Declaration of the CHtm

#ifndef __HTM_H_
#define __HTM_H_

#include "resource.h"       // main symbols
#include <atlctl.h>


/////////////////////////////////////////////////////////////////////////////
// CHtm
class ATL_NO_VTABLE CHtm : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public IDispatchImpl<IHtm, &IID_IHtm, &LIBID_Hh1>,
	public IDispatchImpl<IHtmUI, &IID_IHtmUI, &LIBID_Hh1>,
	public CComControl<CHtm>,
	public IPersistStreamInitImpl<CHtm>,
	public IOleControlImpl<CHtm>,
	public IOleObjectImpl<CHtm>,
	public IOleInPlaceActiveObjectImpl<CHtm>,
	public IViewObjectExImpl<CHtm>,
	public IOleInPlaceObjectWindowlessImpl<CHtm>,
	public IPersistStorageImpl<CHtm>,
	public ISpecifyPropertyPagesImpl<CHtm>,
	public IQuickActivateImpl<CHtm>,
	public IDataObjectImpl<CHtm>,
	public IProvideClassInfo2Impl<&CLSID_Htm, NULL, &LIBID_Hh1>,
	public CComCoClass<CHtm, &CLSID_Htm>
{
public:
	CHtm()
	{
		m_bWindowOnly = TRUE;
	}

DECLARE_REGISTRY_RESOURCEID(IDR_HTM)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CHtm)
	COM_INTERFACE_ENTRY(IHtm)
	COM_INTERFACE_ENTRY(IHtmUI)
	COM_INTERFACE_ENTRY2(IDispatch, IHtm)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY(IQuickActivate)
	COM_INTERFACE_ENTRY(IPersistStorage)
	COM_INTERFACE_ENTRY(IDataObject)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
END_COM_MAP()

BEGIN_PROP_MAP(CHtm)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	// PROP_PAGE(CLSID_StockColorPage)
END_PROP_MAP()

BEGIN_MSG_MAP(CHtm)
	MESSAGE_HANDLER(WM_CREATE, OnCreate)
	CHAIN_MSG_MAP(CComControl<CHtm>)
END_MSG_MAP()
// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);



// IViewObjectEx
	DECLARE_VIEW_STATUS(0)

// IHtm
public:

// IHtmUI
public:
	// Example method called by the HTML to change the <BODY> background color
	STDMETHOD(OnClick)(IDispatch* pdispBody, VARIANT varColor)
	{
		CComQIPtr<IHTMLBodyElement> spBody(pdispBody);
		if (spBody != NULL)
			spBody->put_bgColor(varColor);
		return S_OK;
	}

	LRESULT OnCreate(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
		CAxWindow wnd(m_hWnd);
		HRESULT hr = wnd.CreateControl(IDH_HTM);
		if (SUCCEEDED(hr))
			hr = wnd.SetExternalDispatch(static_cast<IHtmUI*>(this));
		if (SUCCEEDED(hr))
			hr = wnd.QueryControl(IID_IWebBrowser2, (void**)&m_spBrowser);
		return SUCCEEDED(hr) ? 0 : -1;
	}

	CComPtr<IWebBrowser2> m_spBrowser;
};

#endif //__HTM_H_
